from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String

Gsutil_Notification_V0_1_0 = CommandToolBuilder(tool="gsutil_notification", base_command=["gsutil", "notification"], inputs=[ToolInput(tag="in_specify_event_filter", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="Specify an event type filter for this notification config. Cloud\nStorage will only send notifications of this type. You may specify\nthis parameter multiple times to allow multiple event types. If not\nspecified, Cloud Storage will send notifications for all event\ntypes. The valid types are:\nOBJECT_FINALIZE - An object has been created.\nOBJECT_METADATA_UPDATE - The metadata of an object has changed.\nOBJECT_DELETE - An object has been permanently deleted.\nOBJECT_ARCHIVE - A live Cloud Storage object has been archived.")), ToolInput(tag="in_specifies_payload_format", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="Specifies the payload format of notification messages. Must be\neither 'json' for a payload matches the object metadata for the\nJSON API, or 'none' to specify no payload at all. In either case,\nnotification details are available in the message attributes.")), ToolInput(tag="in_specifies_keyvalue_attribute", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc="Specifies a key:value attribute that will be appended to the set\nof attributes sent to Cloud Pub/Sub for all events associated with\nthis notification config. You may specify this parameter multiple\ntimes to set multiple attributes.")), ToolInput(tag="in_specifies_prefix_filter", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="Specifies a prefix path filter for this notification config. Cloud\nStorage will only send notifications for objects in this bucket\nwhose names begin with the specified prefix.")), ToolInput(tag="in_skips_creation_permission", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="Skips creation and permission assignment of the Cloud Pub/Sub topic.\nThis is useful if the caller does not have permission to access\nthe topic in question, or if the topic already exists and has the\nappropriate publish permission assigned.")), ToolInput(tag="in_cloud_pubsub_topic", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="The Cloud Pub/Sub topic to which notifications should be sent. If\nnot specified, this command will choose a topic whose project is\nyour default project and whose ID is the same as the Cloud Storage\nbucket name.")), ToolInput(tag="in_generated_dot", input_type=String(), position=0, doc=InputDocumentation(doc="The optional token parameter can be used to validate notifications events."))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Gsutil_Notification_V0_1_0().translate("wdl", allow_empty_container=True)

